package bank

import (
	"fmt"
	"log"
	"strconv"
	"strings"
	"time"

	"wartank/pkg/components/section"
	"wartank/pkg/types"
	"wartank/server/serv_bots/warbot/angar/base/bank/bankmode"
	"wartank/server/serv_bots/warbot/angar/base/bank/banknet"
	"wartank/server/serv_bots/warbot/tank/tankstat/static_param"
)

/*
	Предоставляет объект банка на базе
*/

// Банк -- объект банка на базе
type Банк struct {
	*section.Section
	net        *banknet.BankNet
	сереброБот types.ИСтатПарам
	mode1      *bankmode.BankMode // 1 режим работы на выбор
	mode2      *bankmode.BankMode // 2 режим работы на выбор
}

// НовБанк -- возвращает новый *Bank
func НовБанк(base types.ИБаза) (*Банк, error) {
	section, ош := section.NewSection(base.Бот(), "Банк", `<span class="green2">Серебро</span><br/>`)
	if ош != nil {
		return nil, fmt.Errorf("НовБанк(): при создании секции банка, ош=\n\t%w", ош)
	}
	сереброБот, ош := static_param.НовСтатПарам("silver_bot")
	if ош != nil {
		return nil, fmt.Errorf("НовБанк(): при создании статы серебра бота, ош=\n\t%w", ош)
	}

	sf := &Банк{
		Section:    section,
		сереброБот: сереброБот,
		mode1:      bankmode.NewBankMode(),
		mode2:      bankmode.NewBankMode(),
	}
	sf.net, ош = banknet.NewBankNet(sf)
	if ош != nil {
		return nil, fmt.Errorf("NewBank(): in create NetBank, err=\n\t%w", ош)
	}
	return sf, nil
}

// Пуск -- запускает банк в работу
func (sf *Банк) Пуск() error {
	log.Printf("Банк.Run()\n")
	go sf.пуск()
	return nil
}

// UpdateLst -- принудительно обновляет состояние банка
func (sf *Банк) UpdateLst() {
	if err := sf.net.UpdateLst(); err != nil {
		log.Printf("Банк.UpdateLst(): err=\n\t%v\n", err)
	}
}

// запускает банк в опрос
func (sf *Банк) пуск() {
	log.Printf("Банк.пуск()\n")
	for {
		// <-sf.ВремяОпрос().КаналСиг()
		if ош := sf.net.UpdateLst(); ош != nil {
			// log._rintf("ERRO Банк.пуск():  при обновлении lstBank, err=\n\t%v\n", err)
			continue
		}
		if ош := sf.получитьВсеРежимы(); ош != nil {
			log.Printf("ERRO Банк.пуск(): при получении списка режимов банка, err=\n\t%v\n", ош)
		}
		_, ош := sf.сделатьСеребро()
		if ош != nil {
			log.Printf("ERRO Банк.пуск(): при пуске производства банка, err=\n\t%v\n", ош)
		}
		time.Sleep(time.Minute * 1)
	}
}

// РежимРаботы2 -- возвращает объект режима2
func (sf *Банк) РежимРаботы2() types.ИБанкРежим {
	return sf.mode2
}

// РежимРаботы1 -- возвращает объект режима1
func (sf *Банк) РежимРаботы1() types.ИБанкРежим {
	return sf.mode1
}

// СереброБот -- возвращает серебро от бота
func (sf *Банк) СереброБот() types.ИСтатПарам {
	return sf.сереброБот
}

// Запускает в производство серебро
func (sf *Банк) сделатьСеребро() (int, error) {
	var (
		lstBank = sf.СписПолучить()
		ind     int
		strOut  string
		strLink string
		isFind  bool
	)
	time1 := sf.РежимРаботы1().ВремяСделать()
	time2 := sf.РежимРаботы2().ВремяСделать()
	if time1 > time2 {
		time1 = time2
	}
	for ind, strOut = range lstBank {
		if strings.Contains(strOut, time1) {
			ind += 7
			strLink = lstBank[ind]
			isFind = true
			break
		}
	}
	if isFind && strings.Contains(strLink, `>Начать производство</span>`) {
		lstLink := strings.Split(strLink, `<a class="simple-but border" href="`)
		strLink = lstLink[1]
		lstLink = strings.Split(strLink, `"><span><span>Начать производство</span></span></a>`)
		strLink = "https://wartank.ru/production/" + lstLink[0]
		lstBank, err := sf.net.Get(strLink)
		if err != nil {
			return -1, fmt.Errorf("BankNet.makeProduct(): при выполнении GET-запроса начать производство, err=%w", err)
		}
		for _, strOut := range lstBank {
			if strings.Contains(strOut, `<title>База</title>`) { // Это база, а не банк
				return 30, nil
			}
		}
		if err = sf.СтрОбновить(lstBank); err != nil {
			return -1, fmt.Errorf("BankNet.makeProduct(): при обновлении lstBank, err=%w", err)
		}
		if err := sf.ParseCountDown(time1); err != nil {
			log.Printf("WARN Банк.makeProduct(): при установке времени производства банка(%v)\n\terr=%v\n", time1, err)
		}
	}
	return sf.ВремяОпрос().Получ(), nil
}

// Получает все режимы банка
func (sf *Банк) получитьВсеРежимы() error {
	var (
		lstBank  = sf.СписПолучить()
		ind      int
		strMode  string
		strMode1 string
		strMode2 string
	)
	{ // Получить первый режим
		for ind, strMode = range lstBank {
			if strings.Contains(strMode, `Кол-во: <span class="green2">`) {
				strMode1 = strMode
				break
			}
		}
		lstMode := strings.Split(strMode1, `Кол-во: <span class="green2">`)
		strMode1 = lstMode[1]
		lstMode = strings.Split(strMode1, `</span><br/>`)
		strMode1 = lstMode[0]
		iNum1, err := strconv.Atoi(strMode1)
		if err != nil {
			return fmt.Errorf("BankNet.getAllMode(): numSilver1(%v) not number, err=\n\t%w", strMode1, err)
		}
		sf.РежимРаботы1().Серебро().Уст(iNum1)
		// Установить время производства
		strTime1 := lstBank[ind+2]
		sf.РежимРаботы1().ВремяСделатьУст(strTime1)
		if iNum1 <= 2 { // Если банк слишком слабый
			return nil
		}
	}
	{ // Получить второй режим
		for _ind := ind + 2; _ind < len(lstBank); _ind++ {
			strMode := lstBank[_ind]
			if strings.Contains(strMode, `Кол-во: <span class="green2">`) {
				strMode2 = strMode
				ind = _ind
				break
			}
		}
		lstMode := strings.Split(strMode2, `Кол-во: <span class="green2">`)
		strMode2 = lstMode[1]
		lstMode = strings.Split(strMode2, `</span><br/>`)
		strMode2 = lstMode[0]
		iNum2, err := strconv.Atoi(strMode2)
		if err != nil {
			return fmt.Errorf("BankNet.getAllMode(): numSilver2(%v) not number, err=\n\t%w", strMode2, err)
		}
		sf.РежимРаботы2().Серебро().Уст(iNum2)
		// Установить время производства
		strTime2 := lstBank[ind+2]
		sf.РежимРаботы2().ВремяСделатьУст(strTime2)
	}
	return nil
}
